<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "listing_site_global_stats".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ListingSiteGlobalStats".
 *
 * Columns in table "listing_site_global_stats" available as properties of the model,
 * followed by relations of table "listing_site_global_stats" available as properties of the model.
 *
 * @property integer $id
 * @property integer $listing_site_id
 * @property integer $estimated_page_views
 * @property string $period_start
 * @property string $query
 * @property string $known_page_view_query
 * @property string $known_page_action_practice_query
 * @property string $known_page_provider_query
 * @property string $known_page_practice_query
 * @property string $date_added
 *
 * @property ListingSite $listingSite
 */
abstract class BaseListingSiteGlobalStats extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'listing_site_global_stats';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ListingSiteGlobalStats|ListingSiteGlobalStats', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('estimated_page_views, date_added', 'required'),
            array('listing_site_id, estimated_page_views', 'numerical', 'integerOnly' => true),
            array('period_start, query, known_page_view_query, known_page_provider_query, known_page_practice_query, known_page_action_query', 'safe'),
            array('listing_site_id, period_start, query, known_page_view_query, known_page_provider_query, known_page_practice_query, known_page_action_practice_query', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, listing_site_id, estimated_page_views, period_start, query, known_page_view_query, known_page_provider_query, known_page_practice_query, known_page_action_practice_query, date_added', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'listingSite' => array(self::BELONGS_TO, 'ListingSite', 'listing_site_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'listing_site_id' => null,
            'estimated_page_views' => Yii::t('app', 'Estimated Page Views'),
            'period_start' => Yii::t('app', 'Period Start'),
            'query' => Yii::t('app', 'Known Page View and Actios Query'),
            'known_page_view_query' => Yii::t('app', 'Known Page View Query'),
            'known_page_action_practice_query' => Yii::t('app', 'Known Page Action Practice Query'),
            'known_page_provider_query' => Yii::t('app', 'Known Page View Provider Query'),
            'known_page_practice_query' => Yii::t('app', 'Known Page View Practice Query'),
            'date_added' => Yii::t('app', 'Date Added'),
            'listingSite' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('listing_site_id', $this->listing_site_id);
        $criteria->compare('estimated_page_views', $this->estimated_page_views);
        $criteria->compare('period_start', $this->period_start, true);
        $criteria->compare('query', $this->query, true);
        $criteria->compare('known_page_view_query', $this->known_page_view_query, true);
        $criteria->compare('known_page_action_practice_query', $this->known_page_action_practice_query, true);
        $criteria->compare('known_page_provider_query', $this->known_page_provider_query, true);
        $criteria->compare('known_page_practice_query', $this->known_page_practice_query, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
